Index: /code/branches/core5/src/libraries/core/CMakeLists.txt
===================================================================
--- /code/branches/core5/src/libraries/core/CMakeLists.txt	(revision 5854)
+++ /code/branches/core5/src/libraries/core/CMakeLists.txt	(revision 5855)
@@ -19,5 +19,4 @@
 
 SET_SOURCE_FILES(CORE_SRC_FILES
-  Clock.cc
   ConfigFileManager.cc
   ConfigValueContainer.cc
Index: de/branches/core5/src/libraries/core/Clock.cc
===================================================================
--- /code/branches/core5/src/libraries/core/Clock.cc	(revision 5854)
+++ 	(revision )
@@ -1,78 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-/**
-    @file
-    @brief
-*/
-
-#include "Clock.h"
-#include <OgreTimer.h>
-
-namespace orxonox
-{
-    Clock::Clock()
-        : timer_(new Ogre::Timer())
-        , storedTime_(0)
-        , tickTime_(0)
-        , tickDt_(0)
-        , tickDtFloat_(0.0f)
-        , lastTimersTime_(0)
-    {
-    }
-
-    Clock::~Clock()
-    {
-        delete timer_;
-    }
-    
-    void Clock::capture()
-    {
-        unsigned long timersTime = timer_->getMicroseconds();
-        tickTime_ = storedTime_ + timersTime;
-        tickDt_ = timersTime - lastTimersTime_;
-        tickDtFloat_ = static_cast<float>(tickDt_) / 1000000.0f;
-
-        if (timersTime > 0xFFFFFFFF/4)
-        {
-            // Ogre timer will overflow at 2^32 microseconds if unsigned long is 32 bit
-            storedTime_ += timersTime;
-            lastTimersTime_ = 0;
-            timer_->reset();
-        }
-        else
-        {
-            lastTimersTime_ = timersTime;
-        }
-    }
-
-    unsigned long long Clock::getRealMicroseconds() const
-    {
-        return this->timer_->getMicroseconds() + this->storedTime_;
-    }
-}
Index: de/branches/core5/src/libraries/core/Clock.h
===================================================================
--- /code/branches/core5/src/libraries/core/Clock.h	(revision 5854)
+++ 	(revision )
@@ -1,67 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-#ifndef _Clock_H__
-#define _Clock_H__
-
-#include "CorePrereqs.h"
-#include "util/OgreForwardRefs.h"
-
-namespace orxonox
-{
-    class _CoreExport Clock
-    {
-    public:
-        Clock();
-        ~Clock();
-
-        void capture();
-
-        unsigned long long getMicroseconds()   const { return tickTime_; }
-        unsigned long long getMilliseconds()   const { return tickTime_ / 1000; }
-        unsigned long      getSeconds()        const { return static_cast<long> (tickTime_ / 1000000); }
-        float              getSecondsPrecise() const { return static_cast<float>(tickTime_ / 1000000.0f); }
-
-        float              getDeltaTime()      const { return tickDtFloat_; }
-        long               getDeltaTimeMicroseconds() const { return tickDt_; }
-
-        unsigned long long getRealMicroseconds() const;
-
-    private:
-        Clock(const Clock& instance);
-
-        Ogre::Timer*       timer_;
-        unsigned long long storedTime_;
-        unsigned long long tickTime_;
-        long               tickDt_;
-        float              tickDtFloat_;
-        unsigned long      lastTimersTime_;
-    };
-}
-
-#endif /* _Clock_H__ */
Index: /code/branches/core5/src/libraries/core/Core.cc
===================================================================
--- /code/branches/core5/src/libraries/core/Core.cc	(revision 5854)
+++ /code/branches/core5/src/libraries/core/Core.cc	(revision 5855)
@@ -48,9 +48,9 @@
 #endif
 
+#include "util/Clock.h"
 #include "util/Debug.h"
 #include "util/Exception.h"
 #include "util/SignalHandler.h"
 #include "PathConfig.h"
-#include "Clock.h"
 #include "CommandExecutor.h"
 #include "CommandLine.h"
Index: /code/branches/core5/src/libraries/core/CorePrereqs.h
===================================================================
--- /code/branches/core5/src/libraries/core/CorePrereqs.h	(revision 5854)
+++ /code/branches/core5/src/libraries/core/CorePrereqs.h	(revision 5855)
@@ -97,5 +97,4 @@
     class ClassTreeMaskNode;
     class ClassTreeMaskObjectIterator;
-    class Clock;
     class CommandEvaluation;
     class CommandExecutor;
Index: /code/branches/core5/src/libraries/core/GUIManager.cc
===================================================================
--- /code/branches/core5/src/libraries/core/GUIManager.cc	(revision 5854)
+++ /code/branches/core5/src/libraries/core/GUIManager.cc	(revision 5855)
@@ -49,9 +49,9 @@
 #endif
 
+#include "util/Clock.h"
 #include "util/Debug.h"
 #include "util/Exception.h"
 #include "util/OrxAssert.h"
 #include "Core.h"
-#include "Clock.h"
 #include "LuaState.h"
 #include "PathConfig.h"
Index: /code/branches/core5/src/libraries/core/Game.cc
===================================================================
--- /code/branches/core5/src/libraries/core/Game.cc	(revision 5854)
+++ /code/branches/core5/src/libraries/core/Game.cc	(revision 5855)
@@ -38,4 +38,5 @@
 #include <boost/weak_ptr.hpp>
 
+#include "util/Clock.h"
 #include "util/Debug.h"
 #include "util/Exception.h"
@@ -43,5 +44,4 @@
 #include "util/Sleep.h"
 #include "util/SubString.h"
-#include "Clock.h"
 #include "CommandLine.h"
 #include "ConsoleCommand.h"
Index: /code/branches/core5/src/libraries/core/GraphicsManager.cc
===================================================================
--- /code/branches/core5/src/libraries/core/GraphicsManager.cc	(revision 5854)
+++ /code/branches/core5/src/libraries/core/GraphicsManager.cc	(revision 5855)
@@ -48,8 +48,8 @@
 
 #include "SpecialConfig.h"
+#include "util/Clock.h"
 #include "util/Exception.h"
 #include "util/StringUtils.h"
 #include "util/SubString.h"
-#include "Clock.h"
 #include "ConsoleCommand.h"
 #include "ConfigValueIncludes.h"
Index: /code/branches/core5/src/libraries/core/TclThreadManager.cc
===================================================================
--- /code/branches/core5/src/libraries/core/TclThreadManager.cc	(revision 5854)
+++ /code/branches/core5/src/libraries/core/TclThreadManager.cc	(revision 5855)
@@ -36,7 +36,7 @@
 #include <cpptcl/cpptcl.h>
 
+#include "util/Clock.h"
 #include "util/Convert.h"
 #include "util/Exception.h"
-#include "Clock.h"
 #include "CommandExecutor.h"
 #include "ConsoleCommand.h"
Index: /code/branches/core5/src/libraries/core/input/InputDevice.h
===================================================================
--- /code/branches/core5/src/libraries/core/input/InputDevice.h	(revision 5854)
+++ /code/branches/core5/src/libraries/core/input/InputDevice.h	(revision 5855)
@@ -41,7 +41,7 @@
 #include <ois/OISInputManager.h>
 
+#include "util/Clock.h"
 #include "util/Debug.h"
 #include "util/Exception.h"
-#include "core/Clock.h"
 #include "InputState.h"
 
Index: /code/branches/core5/src/libraries/core/input/InputManager.cc
===================================================================
--- /code/branches/core5/src/libraries/core/input/InputManager.cc	(revision 5854)
+++ /code/branches/core5/src/libraries/core/input/InputManager.cc	(revision 5855)
@@ -41,8 +41,8 @@
 #include <boost/foreach.hpp>
 
+#include "util/Clock.h"
 #include "util/Convert.h"
 #include "util/Exception.h"
 #include "util/ScopeGuard.h"
-#include "core/Clock.h"
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"
Index: /code/branches/core5/src/libraries/network/Client.cc
===================================================================
--- /code/branches/core5/src/libraries/network/Client.cc	(revision 5854)
+++ /code/branches/core5/src/libraries/network/Client.cc	(revision 5855)
@@ -43,6 +43,6 @@
 #include <cassert>
 
+#include "util/Clock.h"
 #include "util/Debug.h"
-#include "core/Clock.h"
 #include "synchronisable/Synchronisable.h"
 #include "packet/Chat.h"
Index: /code/branches/core5/src/libraries/network/Server.cc
===================================================================
--- /code/branches/core5/src/libraries/network/Server.cc	(revision 5854)
+++ /code/branches/core5/src/libraries/network/Server.cc	(revision 5855)
@@ -46,6 +46,6 @@
 #include <string>
 
+#include "util/Clock.h"
 #include "util/Debug.h"
-#include "core/Clock.h"
 #include "core/ObjectList.h"
 #include "core/Executor.h"
Index: /code/branches/core5/src/libraries/tools/Timer.cc
===================================================================
--- /code/branches/core5/src/libraries/tools/Timer.cc	(revision 5854)
+++ /code/branches/core5/src/libraries/tools/Timer.cc	(revision 5855)
@@ -31,8 +31,8 @@
 #include <set>
 
+#include "util/Clock.h"
 #include "core/CoreIncludes.h"
 #include "core/ConsoleCommand.h"
 #include "core/CommandExecutor.h"
-#include "core/Clock.h"
 #include "core/Functor.h"
 
Index: /code/branches/core5/src/libraries/util/CMakeLists.txt
===================================================================
--- /code/branches/core5/src/libraries/util/CMakeLists.txt	(revision 5854)
+++ /code/branches/core5/src/libraries/util/CMakeLists.txt	(revision 5855)
@@ -20,4 +20,5 @@
 SET_SOURCE_FILES(UTIL_SRC_FILES
   Clipboard.cc
+  Clock.cc
   CRC32.cc
   Exception.cc
Index: /code/branches/core5/src/libraries/util/Clock.cc
===================================================================
--- /code/branches/core5/src/libraries/util/Clock.cc	(revision 5855)
+++ /code/branches/core5/src/libraries/util/Clock.cc	(revision 5855)
@@ -0,0 +1,73 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "Clock.h"
+#include <OgreTimer.h>
+
+namespace orxonox
+{
+    Clock::Clock()
+        : timer_(new Ogre::Timer())
+        , storedTime_(0)
+        , tickTime_(0)
+        , tickDt_(0)
+        , tickDtFloat_(0.0f)
+        , lastTimersTime_(0)
+    {
+    }
+
+    Clock::~Clock()
+    {
+        delete timer_;
+    }
+    
+    void Clock::capture()
+    {
+        unsigned long timersTime = timer_->getMicroseconds();
+        tickTime_ = storedTime_ + timersTime;
+        tickDt_ = timersTime - lastTimersTime_;
+        tickDtFloat_ = static_cast<float>(tickDt_) / 1000000.0f;
+
+        if (timersTime > 0xFFFFFFFF/4)
+        {
+            // Ogre timer will overflow at 2^32 microseconds if unsigned long is 32 bit
+            storedTime_ += timersTime;
+            lastTimersTime_ = 0;
+            timer_->reset();
+        }
+        else
+        {
+            lastTimersTime_ = timersTime;
+        }
+    }
+
+    unsigned long long Clock::getRealMicroseconds() const
+    {
+        return this->timer_->getMicroseconds() + this->storedTime_;
+    }
+}
Index: /code/branches/core5/src/libraries/util/Clock.h
===================================================================
--- /code/branches/core5/src/libraries/util/Clock.h	(revision 5855)
+++ /code/branches/core5/src/libraries/util/Clock.h	(revision 5855)
@@ -0,0 +1,67 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _Clock_H__
+#define _Clock_H__
+
+#include "UtilPrereqs.h"
+#include "OgreForwardRefs.h"
+
+namespace orxonox
+{
+    class _UtilExport Clock
+    {
+    public:
+        Clock();
+        ~Clock();
+
+        void capture();
+
+        unsigned long long getMicroseconds()   const { return tickTime_; }
+        unsigned long long getMilliseconds()   const { return tickTime_ / 1000; }
+        unsigned long      getSeconds()        const { return static_cast<long> (tickTime_ / 1000000); }
+        float              getSecondsPrecise() const { return static_cast<float>(tickTime_ / 1000000.0f); }
+
+        float              getDeltaTime()      const { return tickDtFloat_; }
+        long               getDeltaTimeMicroseconds() const { return tickDt_; }
+
+        unsigned long long getRealMicroseconds() const;
+
+    private:
+        Clock(const Clock& instance);
+
+        Ogre::Timer*       timer_;
+        unsigned long long storedTime_;
+        unsigned long long tickTime_;
+        long               tickDt_;
+        float              tickDtFloat_;
+        unsigned long      lastTimersTime_;
+    };
+}
+
+#endif /* _Clock_H__ */
Index: /code/branches/core5/src/libraries/util/UtilPrereqs.h
===================================================================
--- /code/branches/core5/src/libraries/util/UtilPrereqs.h	(revision 5854)
+++ /code/branches/core5/src/libraries/util/UtilPrereqs.h	(revision 5855)
@@ -63,4 +63,5 @@
 namespace orxonox
 {
+    class Clock;
     class Exception;
     class ExprParser;
Index: /code/branches/core5/src/orxonox/gamestates/GSClient.cc
===================================================================
--- /code/branches/core5/src/orxonox/gamestates/GSClient.cc	(revision 5854)
+++ /code/branches/core5/src/orxonox/gamestates/GSClient.cc	(revision 5855)
@@ -29,6 +29,6 @@
 #include "GSClient.h"
 
+#include "util/Clock.h"
 #include "util/Exception.h"
-#include "core/Clock.h"
 #include "core/CommandLine.h"
 #include "core/Game.h"
Index: /code/branches/core5/src/orxonox/gamestates/GSDedicated.cc
===================================================================
--- /code/branches/core5/src/orxonox/gamestates/GSDedicated.cc	(revision 5854)
+++ /code/branches/core5/src/orxonox/gamestates/GSDedicated.cc	(revision 5855)
@@ -33,7 +33,7 @@
 #include <boost/bind.hpp>
 
+#include "util/Clock.h"
 #include "util/Debug.h"
 #include "util/Sleep.h"
-#include "core/Clock.h"
 #include "core/CommandLine.h"
 #include "core/CommandExecutor.h"
Index: /code/branches/core5/src/orxonox/gamestates/GSDedicatedClient.cc
===================================================================
--- /code/branches/core5/src/orxonox/gamestates/GSDedicatedClient.cc	(revision 5854)
+++ /code/branches/core5/src/orxonox/gamestates/GSDedicatedClient.cc	(revision 5855)
@@ -33,8 +33,8 @@
 #include <boost/bind.hpp>
 
+#include "util/Clock.h"
 #include "util/Debug.h"
 #include "util/Exception.h"
 #include "util/Sleep.h"
-#include "core/Clock.h"
 #include "core/CommandLine.h"
 #include "core/CommandExecutor.h"
Index: /code/branches/core5/src/orxonox/gamestates/GSGraphics.cc
===================================================================
--- /code/branches/core5/src/orxonox/gamestates/GSGraphics.cc	(revision 5854)
+++ /code/branches/core5/src/orxonox/gamestates/GSGraphics.cc	(revision 5855)
@@ -35,6 +35,6 @@
 #include "GSGraphics.h"
 
+#include "util/Clock.h"
 #include "util/Convert.h"
-#include "core/Clock.h"
 #include "core/CommandExecutor.h"
 #include "core/ConsoleCommand.h"
Index: /code/branches/core5/src/orxonox/gamestates/GSLevel.cc
===================================================================
--- /code/branches/core5/src/orxonox/gamestates/GSLevel.cc	(revision 5854)
+++ /code/branches/core5/src/orxonox/gamestates/GSLevel.cc	(revision 5855)
@@ -32,8 +32,8 @@
 #include <OgreCompositorManager.h>
 
+#include "util/Clock.h"
 #include "core/input/InputManager.h"
 #include "core/input/InputState.h"
 #include "core/input/KeyBinder.h"
-#include "core/Clock.h"
 #include "core/ConsoleCommand.h"
 #include "core/ConfigValueIncludes.h"
Index: /code/branches/core5/src/orxonox/gamestates/GSMainMenu.cc
===================================================================
--- /code/branches/core5/src/orxonox/gamestates/GSMainMenu.cc	(revision 5854)
+++ /code/branches/core5/src/orxonox/gamestates/GSMainMenu.cc	(revision 5855)
@@ -31,8 +31,8 @@
 #include <OgreSceneManager.h>
 
+#include "util/Clock.h"
 #include "core/input/InputManager.h"
 #include "core/input/InputState.h"
 #include "core/Game.h"
-#include "core/Clock.h"
 #include "core/ConsoleCommand.h"
 #include "core/GraphicsManager.h"
Index: /code/branches/core5/src/orxonox/gamestates/GSRoot.cc
===================================================================
--- /code/branches/core5/src/orxonox/gamestates/GSRoot.cc	(revision 5854)
+++ /code/branches/core5/src/orxonox/gamestates/GSRoot.cc	(revision 5855)
@@ -29,5 +29,5 @@
 #include "GSRoot.h"
 
-#include "core/Clock.h"
+#include "util/Clock.h"
 #include "core/ConsoleCommand.h"
 #include "core/Game.h"
Index: /code/branches/core5/src/orxonox/overlays/InGameConsole.cc
===================================================================
--- /code/branches/core5/src/orxonox/overlays/InGameConsole.cc	(revision 5854)
+++ /code/branches/core5/src/orxonox/overlays/InGameConsole.cc	(revision 5855)
@@ -41,8 +41,8 @@
 #include <OgreFont.h>
 
+#include "util/Clock.h"
+#include "util/Convert.h"
 #include "util/Math.h"
-#include "util/Convert.h"
 #include "util/UTFStringConversions.h"
-#include "core/Clock.h"
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"