Index: /trunk/src/defs/class_id.h
===================================================================
--- /trunk/src/defs/class_id.h	(revision 5859)
+++ /trunk/src/defs/class_id.h	(revision 5860)
@@ -181,11 +181,12 @@
   CL_FONT                       =    0x00c02802,
   CL_MATERIAL                   =    0x00000804,
-  CL_MODEL                      =    0x00000805, //!< @todo make this a SUBCLASS maybe
-  CL_OBJMODEL                   =    0x00000806,
-  CL_PROMITIVE_MODEL            =    0x00000807,
-  CL_MD2Model                   =    0x00000808,
-  CL_LIGHT                      =    0x00000809,
-  CL_PARTICLE_EMITTER           =    0x0000080a,
-  CL_PARTICLE_SYSTEM            =    0x0000080b,
+  CL_MULTI_FRAME_TEXTURE        =    0x00c04805,
+  CL_MODEL                      =    0x00000806, //!< @todo make this a SUBCLASS maybe
+  CL_OBJMODEL                   =    0x00000807,
+  CL_PROMITIVE_MODEL            =    0x00000808,
+  CL_MD2Model                   =    0x00000809,
+  CL_LIGHT                      =    0x0000080a,
+  CL_PARTICLE_EMITTER           =    0x0000080b,
+  CL_PARTICLE_SYSTEM            =    0x0000080c,
   CL_ENVIRONMENT                =    0x00000810,
   CL_SHADER                     =    0x00000811,
Index: /trunk/src/lib/graphics/importer/multi_frame_texture.cc
===================================================================
--- /trunk/src/lib/graphics/importer/multi_frame_texture.cc	(revision 5859)
+++ /trunk/src/lib/graphics/importer/multi_frame_texture.cc	(revision 5860)
@@ -34,6 +34,10 @@
 MultiFrameTexture::MultiFrameTexture(unsigned int count, ...)
 {
-  this->setClassID(CL_TEXTURE, "Texture");
+  this->setClassID(CL_MULTI_FRAME_TEXTURE, "MultiFrameTexture");
 
+  va_list textureNameList;
+  va_start(textureNameList, count);
+
+  this->loadImageSeries(count, textureNameList);
 }
 
@@ -48,5 +52,7 @@
 
 
-
+/**
+ * rebuilds all the textures from the Images stored in this FrameSequence
+ */
 bool MultiFrameTexture::rebuild()
 {
@@ -64,2 +70,34 @@
 
 }
+
+
+
+bool MultiFrameTexture::loadImageSeries(unsigned int count, ...)
+{
+  va_list textureNameList;
+  va_start(textureNameList, count);
+
+  this->loadImageSeries(count, textureNameList);
+}
+
+bool MultiFrameTexture::loadImageSeries(unsigned int count, va_list textures)
+{
+
+
+}
+
+
+bool MultiFrameTexture::addFrame(const char* imageName)
+{
+
+
+}
+
+
+bool MultiFrameTexture::addFrame(SDL_Surface* surface)
+{
+
+
+}
+
+
Index: /trunk/src/lib/graphics/importer/multi_frame_texture.h
===================================================================
--- /trunk/src/lib/graphics/importer/multi_frame_texture.h	(revision 5859)
+++ /trunk/src/lib/graphics/importer/multi_frame_texture.h	(revision 5860)
@@ -10,5 +10,7 @@
 
 #include "glincl.h"
+
 #include <vector>
+#include <stdarg.h>
 
 /* Forward Declaration */
@@ -16,23 +18,27 @@
 
 //! A Class, that reads in Textures from different fileformats.
-  class MultiFrameTexture : public Texture
-  {
-    public:
-      MultiFrameTexture(unsigned int count, ...);
+class MultiFrameTexture : public Texture
+{
+  public:
+    MultiFrameTexture(unsigned int count = 0, ...);
   //  Texture(TEXTURE_TYPE type, int resolution);
-      ~MultiFrameTexture();
+    ~MultiFrameTexture();
 
-      bool loadImages(unsigned int cound, ...);
-      bool rebuild();
+    bool loadImageSeries(unsigned int count, ...);
+    bool loadImageSeries(unsigned int count, va_list textureNames);
+    bool addFrame(const char* image);
+    bool addFrame(SDL_Surface* surface);
 
-      /** @returns The textureID of this texture.  */
-      inline GLuint getFrameTexture(unsigned int frameNumber) const { return this->textures[frameNumber]; };
+    virtual bool rebuild();
 
-      const SDL_Surface* const getFrameImage(unsigned int frameNumber) const { return this->images[frameNumber]; };
+    /** @returns The textureID of the Frame @param frameNumber the n-th frame this texture-series.  */
+    inline GLuint getFrameTexture(unsigned int frameNumber) const { return this->textures[frameNumber]; };
+    /** @returns The SDL_Surface of the image at Frame @param frameNumber the n-th frame of this image-seriers */
+    const SDL_Surface* const getFrameImage(unsigned int frameNumber) const { return this->images[frameNumber]; };
 
-    private:
-      std::vector<GLuint>          textures;            //!< The Texture-ID of opengl from this Texture.
-      std::vector<SDL_Surface*>    images;              //!< The SDL_Surfce that stores the Texture on it.
-  };
+  private:
+    std::vector<GLuint>          textures;            //!< The Texture-ID of opengl from this Texture.
+    std::vector<SDL_Surface*>    images;              //!< The SDL_Surfce that stores the Texture on it.
+};
 
 #endif /* _MULTI_FRAME_TEXTURE_H */
Index: /trunk/src/lib/graphics/importer/texture.cc
===================================================================
--- /trunk/src/lib/graphics/importer/texture.cc	(revision 5859)
+++ /trunk/src/lib/graphics/importer/texture.cc	(revision 5860)
@@ -116,7 +116,8 @@
 bool Texture::rebuild()
 {
-  if (this->texture != 0 && glIsTexture(this->texture))
+  if (this->texture != 0)
     {
-      glDeleteTextures(1,&this->texture);
+      if (glIsTexture(this->texture))
+        glDeleteTextures(1,&this->texture);
       this->setTexture(0);
     }