Index: /trunk/src/lib/graphics/importer/Makefile.am
===================================================================
--- /trunk/src/lib/graphics/importer/Makefile.am	(revision 5860)
+++ /trunk/src/lib/graphics/importer/Makefile.am	(revision 5861)
@@ -10,5 +10,5 @@
                            material.cc \
                            texture.cc \
-                           multi_frame_texture.cc
+                           texture_sequence.cc
 
 
@@ -21,5 +21,5 @@
                  material.h \
                  texture.h \
-                 multi_frame_texture.h \
+                 texture_sequence.h \
                  anorms.h \
                  anormtab.h
Index: unk/src/lib/graphics/importer/multi_frame_texture.cc
===================================================================
--- /trunk/src/lib/graphics/importer/multi_frame_texture.cc	(revision 5860)
+++ 	(revision )
@@ -1,103 +1,0 @@
-/*
-   orxonox - the future of 3D-vertical-scrollers
-
-   Copyright (C) 2004 orx
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
-   ### File Specific:
-   main-programmer: Benjamin Grauer
-   co-programmer: ...
-*/
-
-#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_IMPORTER
-
-#include "multi_frame_texture.h"
-
-#include "debug.h"
-#include "graphics_engine.h"
-
-#include <stdarg.h>
-
-#ifdef HAVE_SDL_IMAGE_H
-#include <SDL_image.h>
-#else
-#include <SDL/SDL_image.h>
-#endif
-
-/**
- *  Constructor for a Texture
-*/
-MultiFrameTexture::MultiFrameTexture(unsigned int count, ...)
-{
-  this->setClassID(CL_MULTI_FRAME_TEXTURE, "MultiFrameTexture");
-
-  va_list textureNameList;
-  va_start(textureNameList, count);
-
-  this->loadImageSeries(count, textureNameList);
-}
-
-/**
- *  Destructor of a MultiFrameTexture
-
-   Frees Data, and deletes the textures from GL
-*/
-MultiFrameTexture::~MultiFrameTexture()
-{
-}
-
-
-/**
- * rebuilds all the textures from the Images stored in this FrameSequence
- */
-bool MultiFrameTexture::rebuild()
-{
-//   if (this->texture != 0 && glIsMultiFrameTexture(this->texture))
-//     {
-//       glDeleteMultiFrameTextures(1,&this->texture);
-//       this->texture = 0;
-//     }
-//
-//   if (this->image != NULL)
-//     {
-//       PRINTF(3)("Reloading MultiFrameTexture of %s '%s'\n", this->getClassName(), this->getName());
-//       this->texture = loadTexToGL(this->image);
-//     }
-
-}
-
-
-
-bool MultiFrameTexture::loadImageSeries(unsigned int count, ...)
-{
-  va_list textureNameList;
-  va_start(textureNameList, count);
-
-  this->loadImageSeries(count, textureNameList);
-}
-
-bool MultiFrameTexture::loadImageSeries(unsigned int count, va_list textures)
-{
-
-
-}
-
-
-bool MultiFrameTexture::addFrame(const char* imageName)
-{
-
-
-}
-
-
-bool MultiFrameTexture::addFrame(SDL_Surface* surface)
-{
-
-
-}
-
-
Index: unk/src/lib/graphics/importer/multi_frame_texture.h
===================================================================
--- /trunk/src/lib/graphics/importer/multi_frame_texture.h	(revision 5860)
+++ 	(revision )
@@ -1,44 +1,0 @@
-/*!
- * @file texture.h
- * @brief Contains the texture class, that handles the reading of Images into Texutre-files.
- */
-
-#ifndef _MULTI_FRAME_TEXTURE_H
-#define _MULTI_FRAME_TEXTURE_H
-
-#include "texture.h"
-
-#include "glincl.h"
-
-#include <vector>
-#include <stdarg.h>
-
-/* Forward Declaration */
-struct SDL_Surface;
-
-//! A Class, that reads in Textures from different fileformats.
-class MultiFrameTexture : public Texture
-{
-  public:
-    MultiFrameTexture(unsigned int count = 0, ...);
-  //  Texture(TEXTURE_TYPE type, int resolution);
-    ~MultiFrameTexture();
-
-    bool loadImageSeries(unsigned int count, ...);
-    bool loadImageSeries(unsigned int count, va_list textureNames);
-    bool addFrame(const char* image);
-    bool addFrame(SDL_Surface* surface);
-
-    virtual bool rebuild();
-
-    /** @returns The textureID of the Frame @param frameNumber the n-th frame this texture-series.  */
-    inline GLuint getFrameTexture(unsigned int frameNumber) const { return this->textures[frameNumber]; };
-    /** @returns The SDL_Surface of the image at Frame @param frameNumber the n-th frame of this image-seriers */
-    const SDL_Surface* const getFrameImage(unsigned int frameNumber) const { return this->images[frameNumber]; };
-
-  private:
-    std::vector<GLuint>          textures;            //!< The Texture-ID of opengl from this Texture.
-    std::vector<SDL_Surface*>    images;              //!< The SDL_Surfce that stores the Texture on it.
-};
-
-#endif /* _MULTI_FRAME_TEXTURE_H */
Index: /trunk/src/lib/graphics/importer/texture_sequence.cc
===================================================================
--- /trunk/src/lib/graphics/importer/texture_sequence.cc	(revision 5861)
+++ /trunk/src/lib/graphics/importer/texture_sequence.cc	(revision 5861)
@@ -0,0 +1,103 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_IMPORTER
+
+#include "texture_sequence.h"
+
+#include "debug.h"
+#include "graphics_engine.h"
+
+#include <stdarg.h>
+
+#ifdef HAVE_SDL_IMAGE_H
+#include <SDL_image.h>
+#else
+#include <SDL/SDL_image.h>
+#endif
+
+/**
+ *  Constructor for a Texture
+*/
+TextureSequence::TextureSequence(unsigned int count, ...)
+{
+  this->setClassID(CL_TEXTURE_SEQUENCE, "TextureSequence");
+
+  va_list textureNameList;
+  va_start(textureNameList, count);
+
+  this->loadImageSeries(count, textureNameList);
+}
+
+/**
+ *  Destructor of a TextureSequence
+
+   Frees Data, and deletes the textures from GL
+*/
+TextureSequence::~TextureSequence()
+{
+}
+
+
+/**
+ * rebuilds all the textures from the Images stored in this FrameSequence
+ */
+bool TextureSequence::rebuild()
+{
+//   if (this->texture != 0 && glIsTextureSequence(this->texture))
+//     {
+//       glDeleteTextureSequences(1,&this->texture);
+//       this->texture = 0;
+//     }
+//
+//   if (this->image != NULL)
+//     {
+//       PRINTF(3)("Reloading TextureSequence of %s '%s'\n", this->getClassName(), this->getName());
+//       this->texture = loadTexToGL(this->image);
+//     }
+
+}
+
+
+
+bool TextureSequence::loadImageSeries(unsigned int count, ...)
+{
+  va_list textureNameList;
+  va_start(textureNameList, count);
+
+  this->loadImageSeries(count, textureNameList);
+}
+
+bool TextureSequence::loadImageSeries(unsigned int count, va_list textures)
+{
+
+
+}
+
+
+bool TextureSequence::addFrame(const char* imageName)
+{
+
+
+}
+
+
+bool TextureSequence::addFrame(SDL_Surface* surface)
+{
+
+
+}
+
+
Index: /trunk/src/lib/graphics/importer/texture_sequence.h
===================================================================
--- /trunk/src/lib/graphics/importer/texture_sequence.h	(revision 5861)
+++ /trunk/src/lib/graphics/importer/texture_sequence.h	(revision 5861)
@@ -0,0 +1,44 @@
+/*!
+ * @file texture.h
+ * @brief Contains the texture class, that handles the reading of Images into Texutre-files.
+ */
+
+#ifndef _TEXTURE_SEQUENCE_H
+#define _TEXTURE_SEQUENCE_H
+
+#include "texture.h"
+
+#include "glincl.h"
+
+#include <vector>
+#include <stdarg.h>
+
+/* Forward Declaration */
+struct SDL_Surface;
+
+//! A Class, that reads in Textures from different fileformats.
+class TextureSequence : public Texture
+{
+  public:
+    TextureSequence(unsigned int count = 0, ...);
+  //  Texture(TEXTURE_TYPE type, int resolution);
+    ~TextureSequence();
+
+    bool loadImageSeries(unsigned int count, ...);
+    bool loadImageSeries(unsigned int count, va_list textureNames);
+    bool addFrame(const char* image);
+    bool addFrame(SDL_Surface* surface);
+
+    virtual bool rebuild();
+
+    /** @returns The textureID of the Frame @param frameNumber the n-th frame this texture-series.  */
+    inline GLuint getFrameTexture(unsigned int frameNumber) const { return this->textures[frameNumber]; };
+    /** @returns The SDL_Surface of the image at Frame @param frameNumber the n-th frame of this image-seriers */
+    const SDL_Surface* const getFrameImage(unsigned int frameNumber) const { return this->images[frameNumber]; };
+
+  private:
+    std::vector<GLuint>          textures;            //!< The Texture-ID of opengl from this Texture.
+    std::vector<SDL_Surface*>    images;              //!< The SDL_Surfce that stores the Texture on it.
+};
+
+#endif /* _TEXTURE_SEQUENCE_H */